[[!meta title="PineNote with SXMO"]]

<header class="text-center">
    <h1>PineNote with SXMO</h1>
    <hr>
</header>

* add "sway output DPI-1 scale 1.75" to rotate hook + config file


# Display functions

## Controling via /sys/module/rockchip_ebc/parameters

Source:
* [m-weigand's notes on ebc](https://github.com/m-weigand/mw_pinenote_misc/tree/main/rockchip_ebc/patches)
* [extension.js file from pinenote-gnome-extension](https://github.com/PNDeb/pinenote-gnome-extension/blob/20cc2f8fb94f5698401c2289e2b6c602150179ad/pnhelper%40m-weigand.github.com/extension.js)

**bw_mode**

Sets black and white mode of display

Values [0-3]
    * 0: Grayscale (default)
    * 1: Black and white + dithering
    * 2: Black and white
    * 3: DU4 waveform

**bw_threshhold**

Sets threshold where pixel is considered white or black. If default, all pixel values lower than 7 will be cast to 0 (left), and all valuers larger larger or equivalent will be cat to 15 (white)

Values [0-15]
    * 7: default

**auto_refresh**

Controls auto refresh feature

Values
    * 0: disable (default)
    * 1: enable

**refresh_threshold**

Global refreshes are triggered based on the area drawing using partial refreshes, in units of total screen area.

Therefore will trigger a globlal refresh whenever 2 screen areas where drawn.

The threshold should be set according to the application used. For example, evince and xournalpp really like to redraw the screen very often, so a value of 20 suffices. Other require lower numbers.

Values
    * 20: default
    * 60: ideal

**refresh_waveform**

Sets the waveform to use for global refreshes.

Values:
    * 4: default


**dclk_select**

Controls how fast data is sent to the ebc display, allowing for a "quality" mode that reduces visible artifacts as
much as possible, with the downside of having bad latency, and a "performance" mode where speed is gained at the expense
of visual quality.

Values:
    * 0: quality mode (default)
    * 1: performance mode

Display refresh rate should match so that:
    * quality: 5 hz
    * performance: 80 hz

Refresh rate can be set using:
sway output DPI-1 mode 1872x1404@80Hz

Note that current detected maximum is 40 Hz, for some reason.

## Controls via [pinenote_dbus_service](https://github.com/PNDeb/pinenote_dbus_service)


**Refresh screen**

Can be done using the following command:

dbus-send --system --print-reply --dest=org.pinenote.ebc /ebc org.pinenote.ebc.TriggerGlobalRefresh;

Note that this requires the pinenote-dbus-service package

